%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculates output vector
%
% @author Andrea Angioni <aangioni@eonerc.rwth-aachen.de>
% @copyright 2018, Institute for Automation of Complex Power Systems, EONERC
% @license GNU General Public License (version 3)
%
% Statespacemodeldistribution
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function expr_tot = calc_expr_tot_NL(DM,delta,vod,voq,ioD,ioQ,i_LD,i_LQ,fi_PLL,P,Q,fi_d,fi_q,gamma_d,gamma_q,ild,ilq,i_lineD,i_lineQ,i_lineD0,i_lineQ0,vbD,vbQ,V0D,V0Q)
if isempty(DM.inv_count)==1
end
expr_tot=zeros(12*(DM.NGF+DM.NGS)-1+2*DM.Nload+2*DM.Nline+2*DM.PCC,1);
for x = DM.ref : DM.inv_count
    if DM.grid_form(x)~=0
        if x ~= DM.ref
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+12)=[ ...
                fi_PLL(DM.ref)*DM.ki_PLL(DM.ref) - fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(DM.ref)*vod(DM.ref) + DM.kp_PLL(x)*vod(x);...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) - P(x) + V0Q(x)*ioQ(x)));...
                -(DM.wc(x)*(Q(x) + V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                P(x)*DM.m(x) + fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(x)*vod(x);...
                DM.Voqn(x) - voq(x) - Q(x)*DM.n(x);...
                fi_d(x)*DM.kiv_d(x) - ild(x) + DM.kpv_d(x)*(P(x)*DM.m(x) + fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(x)*vod(x));...
                fi_q(x)*DM.kiv_q(x) - ilq(x) - DM.kpv_q(x)*(voq(x) - DM.Voqn(x) + Q(x)*DM.n(x));...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x) - fi_PLL(x)*DM.ki_PLL(x)*DM.kpc_d(x)*DM.kpv_d(x) + DM.kp_PLL(x)*DM.kpc_d(x)*DM.kpv_d(x)*vod(x) - P(x)*DM.kpc_d(x)*DM.kpv_d(x)*DM.m(x))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) - DM.Voqn(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x) + DM.kpc_q(x)*DM.kpv_q(x)*voq(x) + Q(x)*DM.kpc_q(x)*DM.kpv_q(x)*DM.n(x))/DM.Lf(x);...
                (ild(x) - ioD(x)*cos(delta(x)) + ioQ(x)*sin(delta(x)))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                - (ioQ(x)*cos(delta(x)) - ilq(x) + ioD(x)*sin(delta(x)))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        else
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+11)=[ ...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) + V0Q(x)*ioQ(x))) - P(x)*DM.wc(x);...
                - Q(x)*DM.wc(x) - (DM.wc(x)*(V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                P(x)*DM.m(x) + fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(x)*vod(x);...
                DM.Voqn(x) - voq(x) - Q(x)*DM.n(x);...
                fi_d(x)*DM.kiv_d(x) - ild(x) + DM.kpv_d(x)*(P(x)*DM.m(x) + fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(x)*vod(x));...
                fi_q(x)*DM.kiv_q(x) - ilq(x) - DM.kpv_q(x)*(voq(x) - DM.Voqn(x) + Q(x)*DM.n(x));...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x) - fi_PLL(x)*DM.ki_PLL(x)*DM.kpc_d(x)*DM.kpv_d(x) + DM.kp_PLL(x)*DM.kpc_d(x)*DM.kpv_d(x)*vod(x) - P(x)*DM.kpc_d(x)*DM.kpv_d(x)*DM.m(x))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) - DM.Voqn(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x) + DM.kpc_q(x)*DM.kpv_q(x)*voq(x) + Q(x)*DM.kpc_q(x)*DM.kpv_q(x)*DM.n(x))/DM.Lf(x);...
                (ild(x) - ioD(x))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                (ilq(x) - ioQ(x))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        end
        
    elseif DM.grid_supp_PV(x)~=0
        if x ~= DM.ref
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+12)=[ ...
                fi_PLL(DM.ref)*DM.ki_PLL(DM.ref) - fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(DM.ref)*vod(DM.ref) + DM.kp_PLL(x)*vod(x);...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) - P(x) + V0Q(x)*ioQ(x)));...
                -(DM.wc(x)*(Q(x) + V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                DM.G*DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2) - Q(x);...
                DM.G*DM.PF(x)*DM.Pmax(x) - P(x);...
                fi_d(x)*DM.kiv_d(x) - ild(x) - DM.kpv_d(x)*(Q(x) - DM.G*DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2));...
                fi_q(x)*DM.kiv_q(x) - ilq(x) - DM.kpv_q(x)*(P(x) - DM.G*DM.PF(x)*DM.Pmax(x));...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) + Q(x)*DM.kpc_d(x)*DM.kpv_d(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x) - DM.G*DM.Pmax(x)*DM.kpc_d(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) + P(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x) - DM.G*DM.PF(x)*DM.Pmax(x)*DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x);...
                (ild(x) - ioD(x)*cos(delta(x)) + ioQ(x)*sin(delta(x)))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                - (ioQ(x)*cos(delta(x)) - ilq(x) + ioD(x)*sin(delta(x)))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        else
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+11)=[ ...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) + V0Q(x)*ioQ(x))) - P(x)*DM.wc(x);...
                - Q(x)*DM.wc(x) - (DM.wc(x)*(V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                DM.G*DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2) - Q(x);...
                DM.G*DM.PF(x)*DM.Pmax(x) - P(x);...
                fi_d(x)*DM.kiv_d(x) - ild(x) - DM.kpv_d(x)*(Q(x) - DM.G*DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2));...
                fi_q(x)*DM.kiv_q(x) - ilq(x) - DM.kpv_q(x)*(P(x) - DM.G*DM.PF(x)*DM.Pmax(x));...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) + Q(x)*DM.kpc_d(x)*DM.kpv_d(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x) - DM.G*DM.Pmax(x)*DM.kpc_d(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) + P(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x) - DM.G*DM.PF(x)*DM.Pmax(x)*DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x);...
                (ild(x) - ioD(x))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                (ilq(x) - ioQ(x))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        end
    elseif DM.grid_supp_PQ(x)~=0
        if x ~= DM.ref
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))-1+12)=[ ...
                fi_PLL(DM.ref)*DM.ki_PLL(DM.ref) - fi_PLL(x)*DM.ki_PLL(x) - DM.kp_PLL(DM.ref)*vod(DM.ref) + DM.kp_PLL(x)*vod(x);...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) - P(x) + V0Q(x)*ioQ(x)));...
                -(DM.wc(x)*(Q(x) + V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                DM.Q_obj(x) - Q(x);...
                DM.P_obj(x) - P(x);...
                DM.kpv_d(x)*(DM.Q_obj(x) - Q(x)) - ild(x) + fi_d(x)*DM.kiv_d(x);...
                DM.kpv_q(x)*(DM.P_obj(x) - P(x)) - ilq(x) + fi_q(x)*DM.kiv_q(x);...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) - DM.Q_obj(x)*DM.kpc_d(x)*DM.kpv_d(x) + Q(x)*DM.kpc_d(x)*DM.kpv_d(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) - DM.P_obj(x)*DM.kpc_q(x)*DM.kpv_q(x) + P(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x))/DM.Lf(x);...
                (ild(x) - ioD(x)*cos(delta(x)) + ioQ(x)*sin(delta(x)))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                - (ioQ(x)*cos(delta(x)) - ilq(x) + ioD(x)*sin(delta(x)))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        else
            expr_tot(12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+1:12*(sum(DM.grid_supp(1:x-1) + DM.grid_form(1:x-1)))+11)=[ ...
                -vod(x);...
                (DM.wc(x)*(V0D(x)*ioD(x) + V0Q(x)*ioQ(x))) - P(x)*DM.wc(x);...
                - Q(x)*DM.wc(x) - (DM.wc(x)*(V0D(x)*ioQ(x) - V0Q(x)*ioD(x)));...
                DM.Q_obj(x) - Q(x);...
                DM.P_obj(x) - P(x);...
                DM.kpv_d(x)*(DM.Q_obj(x) - Q(x)) - ild(x) + fi_d(x)*DM.kiv_d(x);...
                DM.kpv_q(x)*(DM.P_obj(x) - P(x)) - ilq(x) + fi_q(x)*DM.kiv_q(x);...
                -(vod(x) - gamma_d(x)*DM.kic_d(x) + ild(x)*DM.kpc_d(x) + ild(x)*DM.rf(x) - DM.Q_obj(x)*DM.kpc_d(x)*DM.kpv_d(x) + Q(x)*DM.kpc_d(x)*DM.kpv_d(x) - fi_d(x)*DM.kiv_d(x)*DM.kpc_d(x))/DM.Lf(x);...
                -(voq(x) - gamma_q(x)*DM.kic_q(x) + ilq(x)*DM.kpc_q(x) + ilq(x)*DM.rf(x) - DM.P_obj(x)*DM.kpc_q(x)*DM.kpv_q(x) + P(x)*DM.kpc_q(x)*DM.kpv_q(x) - fi_q(x)*DM.kiv_q(x)*DM.kpc_q(x))/DM.Lf(x);...
                (ild(x) - ioD(x))/DM.Cf(x) + 2*DM.f*voq(x)*pi;...
                (ilq(x) - ioQ(x))/DM.Cf(x) - 2*DM.f*vod(x)*pi;...
                ];
        end
    end
end
for x = 1 : DM.Nnode
    if DM.plac_load(x)==1
        expr_tot(12*(DM.NGF+DM.NGS)-1+2*sum(DM.plac_load(1:x-1))+1:12*(DM.NGF+DM.NGS)-1+2*sum(DM.plac_load(1:x-1))+2) = [...
            -(2*DM.f*pi*(i_LD(x)*(1 - DM.PF(x)^2)^(1/2) - DM.PF(x)*i_LQ(x) + ioD(x)*(1 - DM.PF(x)^2)^(1/2)))/DM.PF(x);...
            -(2*DM.f*pi*(DM.PF(x)*i_LD(x) + i_LQ(x)*(1 - DM.PF(x)^2)^(1/2) + ioQ(x)*(1 - DM.PF(x)^2)^(1/2)))/DM.PF(x);...
            ];
    end
end
if DM.PCC == 1
    expr_tot(12*(DM.NGF+DM.NGS)-1+2*DM.Nload+1:12*(DM.NGF+DM.NGS)-1+2*DM.Nload+2) = [...
        2*DM.f*i_lineQ0*pi - (vbD(1) - DM.Eod + DM.Rcc*i_lineD0)/DM.Lcc;...
        - (vbQ(1) - DM.Eoq + DM.Rcc*i_lineQ0)/DM.Lcc - 2*DM.f*i_lineD0*pi;...
        ];
end
for x = 1 : DM.Nline
    expr_tot(12*(DM.NGF+DM.NGS)-1+2*DM.Nload+2*DM.PCC+2*(x-1)+1:12*(DM.NGF+DM.NGS)-1+2*DM.Nload+2*DM.PCC+2*x) = [...
        2*DM.f*i_lineQ(x)*pi - (vbD(DM.topology(2,x)) - vbD(DM.topology(1,x)) + i_lineD(x)*DM.rline(x))/DM.Lline(x);...
        - (vbQ(DM.topology(2,x)) - vbQ(DM.topology(1,x)) + i_lineQ(x)*DM.rline(x))/DM.Lline(x) - 2*DM.f*i_lineD(x)*pi;...
        ];
end
end